/*
 *  polyMath.h
 *  fp
 *
 *  Created by Robert Delaney on 5/17/13.
 *  Copyright 2013 Bob Delaney's Science Software. All rights reserved.
 *
 */

#pragma once

poly polyNormalize(const poly& x);
poly polyReduce(const poly& x);
int compare(const poly& x, const poly& y);
void polyOverZ(poly& z, const poly& x);
poly polyOverZ(const poly& x);
poly polyDeriv(const poly& x);
void add(poly& z, const poly& x, const poly& y);
void sub(poly& z, const poly& x, const poly& y);
void mul(poly& z, const poly& x, const poly& y);
void divEuclid(poly& q, poly& r, const poly& x, const poly& y);
void divEuclid(poly& q, poly& r, const poly& x, const poly& y, double p);
void div(poly& z, const poly& x, const poly& y);
void add(poly& z, const poly& x, const bf& y);
void sub(poly& z, const poly& x, const bf& y);
void mul(poly& z, const poly& x, const bf& y);
void div(poly& z, const poly& x, const bf& y);
void add(poly& z, const bf& x, const poly& y);
void sub(poly& z, const bf& x, const poly& y);
void mul(poly& z, const bf& x, const poly& y);
void div(poly& z, const bf& x, const poly& y);
poly gcd(const poly& x, const poly& y);
poly gcd(const poly& x, const poly& y, double q);
poly polyMod(const poly& x, const poly& y);
poly polyMod(const poly& x, const poly& y, double q);
poly polyMod(const poly& x, const mb& q);
poly polyMod(const poly& x, double q);
void polySquareFree(poly*& z, long& numPolys, const poly& x);
void findPowersOfSquareFreeFactors(char*& zString, long& numPolys, const poly& x);
void findPowersOfSquareFreeFactors(poly*& z1, long*& theExp, long& numPolys, const poly& x);
void polyPow(poly& z, const poly& x, INT32 p);
poly polyPow(const poly& x, INT32 p);
void polyPowerMod(poly& z, const poly& x, INT32 p, const poly& y);
void polyPowerMod(poly& z, const poly& x, INT32 p, const poly& y, double q);
poly polyPowerMod(const poly& x, INT32 p, const poly& y);
poly polyPowerMod(const poly& x, INT32 p, const poly& y, double q);
